(define (domain blocks-world)
  (:requirements :strips)
  (:predicates (on ?x ?y)
	             (ontable ?x)
	             (clear ?x)
	             (holding ?x)
               (handempty)
  )

  (:action pick-up-from-table
    :parameters (?x)
    :precondition
    (and
      (clear ?x)
      (ontable ?x)
      (handempty)
    )
    :effect
    (and
      (not (clear ?x))
      (not (ontable ?x))
      (not (handempty))
      (holding ?x)
    )
  )

  (:action put-down-on-table
    :parameters (?x)
    :precondition (holding ?x)
    :effect
    (and
      (not (holding ?x))
      (clear ?x)
      (ontable ?x)
      (handempty)
    )
  )

  (:action pick-up-from-block
    :parameters (?x ?y)
    :precondition
    (and
      (clear ?x)
      (on ?x ?y)
      (handempty)
    )
    :effect
    (and
      (not (clear ?x))
      (not (on ?x ?y))
      (not (handempty))
      (holding ?x)
      (clear ?y)
    )
  )

  (:action put-down-on-block
    :parameters (?x ?y)
    :precondition
    (and
      (holding ?x)
      (clear ?y)
    )
    :effect
    (and
      (not (holding ?x))
      (not (clear ?y))
      (clear ?x)
      (on ?x ?y)
      (handempty)
    )
  )
)
